name: ci

on:
  push:
    branches:
      - "main"

jobs:
  builder:
    runs-on: docker
    container:
      image: node:23-alpine
    steps:
      - name: Check out code
        uses: actions/checkout@v4

      - name: Set up QEMU
        uses: docker/setup-qemu-action@v2

      - name: Set up context
        uses: docker context create builders

      - name: Set up Docker Build
        uses: docker/setup-buildx-action@v2
        with:
          version: latest
          endpoint: builders
      
      - name: Login to Docker Registry
        uses: docker/login-action@v3
        with:
          registry: ${{ vars.REGISTRY_URL }}
          username: ${{ secrets.REGISTRY_USERNAME }}
          password: ${{ secrets.REGISTRY_TOKEN }}
      
      - name: Build and push
        uses: docker/build-push-action@v6
        with:
          push: true
          platforms: linux/amd64,linux/arm64
          tags: ${{ vars.REGISTRY_URL }}/${{ env.GITHUB_REPOSITORY }}:latest